#! gsi-script

;;; File: "clock.scm"

(define (needle t secs-per-turn length)
  (let* ((n (modulo (round (inexact->exact t)) secs-per-turn))
         (a (exact->inexact (* 2 3.1416 (/ n secs-per-turn))))
         (x (* length (sin a)))
         (y (* length (cos a))))
    (glBegin GL_LINES)
    (glVertex3d 0.0 0.0 0.0)
    (glVertex3d x y 0.0)
    (glEnd)))

(define start (time->seconds (current-time)))

(c-define (my-idle-func) () void "my_idle_func" ""
  (thread-sleep! 0.1)
  (if (> (time->seconds (current-time))
         (+ start 3))
      (exit)) ;; exit after 3 seconds
  (my-display-func))

(c-define (my-display-func) () void "my_display_func" ""
  (let ((t (time->seconds (current-time))))
    (glClearColor 1.0 1.0 1.0 0.0)
    (glClear GL_COLOR_BUFFER_BIT)
    (glLineWidth 6.0)
    (glColor3d 1.0 0.0 0.0)
    (needle t (* 12 60 60) 0.5)
    (glLineWidth 3.0)
    (glColor3d 0.0 1.0 0.0)
    (needle t (* 60 60) 0.6)
    (glLineWidth 2.0)
    (glColor3d 0.0 0.0 1.0)
    (needle t 60 0.7))
  (glFlush))

(glutInit (command-line))

(glutCreateWindow "Clock")

(glutIdleFunc my-idle-func)
(glutDisplayFunc my-display-func)

(glutMainLoop)
